Package: SigsPack
Type: Package
Title: Mutational Signature Estimation for Single Samples
Version: 1.25.0
Author: Franziska Schumann <franziska.schumann@student.hpi.de>
Maintainer: Franziska Schumann <franziska.schumann@student.hpi.de>
Description: Single sample estimation of exposure to mutational signatures.
    Exposures to known mutational signatures are estimated for single samples,
    based on quadratic programming algorithms. Bootstrapping the input
    mutational catalogues provides estimations on the stability of these 
    exposures. The effect of the sequence composition of mutational context
    can be taken into account by normalising the catalogues.
License: GPL-3
Encoding: UTF-8
Depends: R (>= 3.6)
biocViews: SomaticMutation, SNP, VariantAnnotation,
        BiomedicalInformatics, DNASeq
Imports: quadprog (>= 1.5-5), methods, Biobase, BSgenome (>= 1.46.0),
        VariantAnnotation (>= 1.24.5), Biostrings, GenomeInfoDb,
        GenomicRanges, rtracklayer, SummarizedExperiment, graphics,
        stats, utils
Suggests: IRanges, BSgenome.Hsapiens.UCSC.hg19, BiocStyle, knitr,
        rmarkdown
VignetteBuilder: knitr
BiocViews:
BugReports: https://github.com/bihealth/SigsPack/issues
URL: https://github.com/bihealth/SigsPack
Collate: bootstrap_mut_catalogues.R cosmicSigs.R sigProfilerExome.R
        sigProfiler20190522.R create_mut_catalogues.R decomposeQP.R
        get_context_freq.R hg19context_freq.R normalize.R
        plot_bootstrapped_exposure.R signature_exposure.R
        summarize_exposures.R vcf2mut_cat.R
RoxygenNote: 6.1.1
LazyData: true
git_url: https://git.bioconductor.org/packages/SigsPack
git_branch: devel
git_last_commit: 76511e2
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.23
Date/Publication: 2025-11-04
NeedsCompilation: no
Packaged: 2025-11-05 01:00:13 UTC; biocbuild

# SigsPack
SigsPack is a R package for mutational signatures estimation. 

Mutational signatures are specific patterns of somatic mutations introduced into the genome by oncogenic processes. 
Different mutational processes often generate different combinations of mutations, or signatures, 
that have been previously described. Identification of the processes contributing to mutations observed in a sample 
is potentially informative to understand the cancer etiology. 

SigsPack provides estimations of a sample's exposure to mutational processes described by a set of known mutational 
signatures (for example from COSMIC). The exposure stability is quantified by bootstrapping the mutational catalogue.

#' Estimates the signature exposure of a mutational catalogue
#'
#' Estimates the signature exposure of a mutational catalogue by reconstructing
#' it from a chosen set of signatures, by default, the used method is quadratic
#' programming
#'
#' @param mut_cat matrix (f by n) conatining one or several mutational 
#' catalogues of samples whose signature exposures are to be estimated
#' f is the amount of features that the profiles are defined on
#' n is the number of catalogues
#' @param P Matrix (f by k) containing the signature profiles of k
#' signatures whose exposure is to be found
#' k is the amount of signature profiles that P contains
#' f is the amount of features that the profiles are defined on
#' (default: COSMIC signature matrix 96 x 30)
#' @param sig_set Numeric vector containing the index of the columns from the
#' signature matrix (which are the signature profiles) that will be used
#' reconstruct the mutational catalogue.
#' @param FUN Function to estimate the signature exposure. Default: Quadratic 
#' programming (P has to be of full rank to use this method)
#' @param ... control parameters that will be passed to FUN
#'
#' @return List of the estimated signature exposure, the reconstructed profile
#' of the sample, the cosine similarity between the two and the error
#'
#' @examples
#' data(cosmicSigs)
#' signature_exposure(create_mut_catalogues(10,500)[['catalogues']])
#' signature_exposure(create_mut_catalogues(10,500)[['catalogues']], sig_set = c(2,7,16,28,30))
#' signature_exposure(as.matrix(create_mut_catalogues(10,500)[['catalogues']][,1]))
#' 
#' 
#'
#' @export
signature_exposure <- function(mut_cat,
                               P = get(utils::data("cosmicSigs", package="SigsPack")),
                               sig_set = NULL, FUN=decomposeQP, ... ){
    
    if (! is.matrix(P)){
        stop('P should be a matrix', call. = TRUE)
    }
    if (ncol(P) == 1){
        stop("Matrix 'P' must have at least 2 columns.", call. = TRUE)
    }
    if (! is.numeric(mut_cat)){
        stop('The mutational catalogue is expected to contain only numbers.',
             call. = TRUE)
    }
    if (nrow(mut_cat) != nrow(P)){
        stop("The mutational catalogues (mut_cat) and the signatures (P) must
         have the same number of rows.", call. = TRUE)
    }
    nsigs <- ncol(P)
    nfeatures <- nrow(P)
    
    # in case the catalogue is a vector
    mut_cat <- as.matrix(mut_cat)
    sample_names <- paste0('sample_', seq_len(ncol(mut_cat)))
    colnames(mut_cat) <- sample_names
    
    if (is.null(sig_set)){
        sig_set  <- c(seq_len(nsigs))
    }
    else if (!is.numeric(sig_set) || length(sig_set) < 1){
        stop('sig_set has to be a vector containing numeric values', call. = TRUE)
    }
    else if (max(sig_set) > nsigs){
        stop('The signature matrix P has less columns then sig_set is accessing',
             call. = TRUE)
    }
    
    P_adj <- P[,sig_set]
    
    # Add warning for low counts
    tmp <- colSums(mut_cat, na.rm=TRUE)
    if (isTRUE(all.equal(tmp, round(tmp))) &&
        isFALSE(all.equal(tmp, 1)) &&
        min(tmp) < 125)
        warning(paste("Low number of mutations (",
                      min(tmp),
                      "), exposures may be unreliable"))
    
    # some parts are from 'findSigExposure' in SigEs
    mut_cat <- apply(mut_cat, 2, function(x) {
        x/sum(x)
    })
    estimate <- apply(mut_cat, 2, function(x) {
        FUN(x, P_adj, ...)
    })
    reconstructed <- t(t(estimate)%*%t(P_adj))
    estimate_adj = matrix(0L,  nrow = dim(P)[2], ncol = dim(mut_cat)[2])
    estimate_adj[sig_set,] <- estimate
    rownames(estimate_adj) <- colnames(P)
    colnames(estimate_adj) <- colnames(mut_cat)
    
    
    # error
    errors <- (mut_cat - reconstructed)**2
    errors <- as.matrix(colSums(errors))
    rownames(errors) <- colnames(mut_cat)
    colnames(errors) <- c('error')
    cossim <- numeric(length = ncol(mut_cat))
    for(i in seq_len(ncol(mut_cat))){
        cossim[i] <- as.numeric(mut_cat[,i] %*% reconstructed[,i]/(sqrt(mut_cat[,i] %*% mut_cat[,i]) * sqrt(reconstructed[,i] %*% reconstructed[,i])))
    }
    res <- list(estimate_adj, reconstructed, cossim, errors)
    names(res) <- c('exposures', 'reconstructed profiles', 'cosine similarity',
                    'errors')
    
    return(res)
}

#' Signature exposure analysis of a mutational catalogue
#'
#' Bootstrapps a mutational catalogue and details the results about the 
#' signature estimation in a table and a boxplot
#'
#' @param mut_cat mutational catalogue (96 by 1)
#' @param P Matrix (f x k) containing the signature profiles of k
#' signatures whose exposure is to be found
#' k is the amount of signature profiles that P contains
#' f is the amount of features that the profiles are defined on
#' (default: COSMIC signature matrix 96 by 30)
#' @param m numeric, amount of mutations in the profile (needed for 
#' bootstrapping in case mut_cat doesn't contain absolute counts.)
#' @param plotting boolean, TRUE by default, if True,  a boxplot showing the 
#' distribution of estimated signature exposure for all the re-samples, 
#' highlighting the one of the original mutational catalogue, thus providing 
#' insights on the reliability of the estimates
#'
#' @return table (k by 6) containing statistics for each signature about the 
#' estimated exposure over 1000 bootstrapped resamples
#' - original exposure estimated exposure of the original mutational profile
#' - min minimum estimated exposure to this signature
#' - 1. quartile
#' - median 
#' - 3. quartile
#' - max maximum estimated exposure to this signature
#'
#' if the plotting option is chosen, a boxplot will also be displayed
#' 
#' @examples
#' summarize_exposures(create_mut_catalogues(10,500)[['catalogues']][,1], plotting=FALSE)
#' 
#' @export
summarize_exposures <- function(mut_cat,
                                P = get(utils::data("cosmicSigs", package="SigsPack")),
                                plotting=TRUE, m=NULL){
    
    if (! is.numeric(mut_cat)){
        stop('The mutational catalogue is expected to contain only numbers.',
             call. = TRUE)
    }
    mut_cat <- as.matrix(mut_cat)
    
    QPoriginal <- signature_exposure(mut_cat, P)
    
    if(is.null(m)){
        m <- colSums(mut_cat)
    }
    bootstrapped <- bootstrap_mut_catalogues(1000, mut_cat[,1], m)
    
    QPbootstrapped <- signature_exposure(bootstrapped, P)
    
    exposure_stats <- matrix(nrow = ncol(P), ncol = 6)
    rownames(exposure_stats) = colnames(P)
    colnames(exposure_stats) = c('original exposure', 'min','1. quartile',
                                 'median', '3. quartile', 'max')
    original_exposures <- QPoriginal[['exposures']][,1]
    boot_exposures <- QPbootstrapped[['exposures']]
    
    exposure_stats[,1] <- original_exposures
    exposure_stats[,2] <- Biobase::rowMin(boot_exposures)
    exposure_stats[,3] <- apply(boot_exposures, 1, function(x){
        stats::quantile(x, 0.25)
    })
    exposure_stats[,4] <- Biobase::rowMedians(boot_exposures)
    exposure_stats[,5] <- apply(boot_exposures, 1, function(x){
        stats::quantile(x, 0.75)
    })
    exposure_stats[,6] <- Biobase::rowMax(boot_exposures)
    
    #==========================================================================
    #Plot
    if(plotting){
        plot_bootstrapped_exposure(boot_exposures, as.matrix(QPoriginal[['exposures']]))
    }
    #==========================================================================
    
    return(exposure_stats)
}

#' COSMIC Signature Profiles
#'
#' @format A matrix with 30 rows and 96 columns containing the signature 
#' profiles of the 30 consensus signatures as reported on COSMIC.
#' 
#'\describe{
#'\item{Signature N}{The profile of signature N representing the relative
#'proportions of mutations generated by each signature based on the 
#'trinucleotide frequencies of hte reference human genome version GRCh37.}#'}
#'
#' @source \url{https://cancer.sanger.ac.uk/cancergenome/assets/signatures_probabilities.txt}
"cosmicSigs"

#' Creates simulated mutational catalogues
#'
#' Creates mutational catalogues from chosen mutational signature profiles to
#' gain simualted data sampled from a distirbution with with known signature
#' contribution
#'
#' @param n Amount of mutational catalogues that will be created
#' @param m Amount of mutations that each catalogues will have
#' @param P Matrix (f x k) containing the signature profiles of k signatures
#' which will be used to create the catalogues
#' k is the amount of signature profiles that P contains
#' f is the amount of features that the profiles are defined on
#' (default: COSMIC signature matrix 96 x 30) (optional)
#' @param sig_set Numeric vector containing the index of the columns from P
#' (which are the signature profiles) that will be used to create the catalogues
#' (optional). Defaults to all columns of P.
#' @param c_exposure Numeric vector specifying the contribution of each 
#' signature to the distribution each sample is drawn from. Samples will have an
#' appr. exposure of c_exposure[idx] to signature sig_set[idx] 
#' (if sum(c_exposure)==1). (optional)
#' Default: random exposure.
#'
#' @return List containing a matrix (f x n) with the simulated catalogues and a
#' matrix (k x n) detailing the signature exposure of each catalogue
#'
#' @examples
#' data(cosmicSigs)
#' sim_data <- create_mut_catalogues(10, 300, cosmicSigs, c(2,6,15,27))
#' sim_data <- create_mut_catalogues(1000, 500)
#' sim_data <- create_mut_catalogues(1, 500, sig_set = c(1,4,29), c_exposure = c(0.25, 0.65, 0.1))
#'
#' @export
create_mut_catalogues <- function(n, m,
                                  P=get(utils::data("cosmicSigs", package="SigsPack")),
                                  sig_set = NULL,
                                  c_exposure = NULL){
    if (! is.matrix(P)){
        stop('P should be a matrix', call. = TRUE)
    }
    
    if (!is.numeric(n) || n < 1){
        stop('n has to be a positive number', call. = TRUE)
    }
    
    if (!is.numeric(m) || m < 1){
        stop('m has to be a positive number', call. = TRUE)
    }
    
    nsigs <- ncol(P)
    nfeatures <- nrow(P)
    
    if (is.null(sig_set)){
        sig_set  <- c(seq_len(nsigs))
    }
    else if (!is.numeric(sig_set) || length(sig_set) < 1){
        stop('sig_set has to be a vector containing numeric values', call. = TRUE)
    }
    else if (max(sig_set) > nsigs){
        stop('The signature matrix P has less columns then sig_set is accessing',
             call. = TRUE)
    }
    
    if (!is.null(c_exposure)) {
        if(!is.numeric(c_exposure)){
            stop('c_exposure has to be a vector containing numeric values',
                 call. = TRUE)
        }
        else if(length(c_exposure) != length(sig_set)){
            stop('c_exposure has to be a vector of the same length as sig_set',
                 call. = TRUE)
        }
        if(sum(c_exposure) != 1){
            warning('c_exposure does not add up to one, the weights will be scaled 
              accordingly')
            c_exposure = c_exposure/sum(c_exposure)
        }
        
    }
    
    #============================================================================
    #create catalogues
    catalogues = matrix(0, nrow = nfeatures, ncol = n)
    exposure = matrix(0, nrow = nsigs, ncol = n)
    
    for (i in seq_len(n)) {
        v = matrix(0,nrow = nsigs, ncol = 1)
        for (j in seq_len(length(sig_set))){
            if (is.null(c_exposure)){
                v[sig_set[j]] <- stats::runif(1, 0, 1)
            }
            else{
                v[sig_set[j]] <- c_exposure[j]
            }
        }
        v <- v/sum(v)
        p <- P %*% v
        p <- p/sum(p)
        exposure[,i] <- v
        
        #sample
        mutations_sampled <- sample(seq(nfeatures), m, replace = TRUE, prob = p)
        sample <- as.numeric(table(factor(mutations_sampled,
                                          levels = seq(nfeatures))))
        catalogues[,i] <- sample
    }
    
    sample_names <- paste0('sample_', seq_len(n))
    rownames(catalogues) <- rownames(P)
    rownames(exposure) <- colnames(P)
    colnames(catalogues) <- sample_names
    colnames(exposure) <- sample_names
    
    sim_data <- list(catalogues, exposure)
    names(sim_data) <- c('catalogues', 'exposure')
    
    return(sim_data)
}

#' Bootstraps a given mutational catalogue
#'
#' Bootstraps a given mutational catalogue  by replicating samples from the
#' original catalogue's distribution of mutational features. The output can be
#' input to signature_exposure.
#'
#' @param n Amount of bootstrapped replicates that are created (they will by
#' default have the same amount of mutations as the original catalogue)
#' @param original Mutational catalogue (matrix) of a sample that is taken as
#' the distribution from which the replicates are sampled
#' @param m Amount of mutations the replicates are supposed to have
#' (e.g. if this differs from the original or if the original is provided as
#' probabilities instead of total counts)
#'
#' @return matrix containing the mutational catalogues of the replicates
#'
#' @examples
#' data(cosmicSigs)
#' reps <- bootstrap_mut_catalogues(n = 150, original = create_mut_catalogues(
#'                                   10, 500)[["catalogues"]][,1])
#'
#' @export
bootstrap_mut_catalogues <- function(n, original, m = NULL){
    if (!is.numeric(n) || n < 1){
        stop('n has to be a positive number', call. = TRUE)
    }
    
    if (! is.numeric(original)){
        stop('The original mutational catalogue is expected to contain only
         numbers.'
             ,call. = TRUE)
    }
    
    if(is.null(m)){
        m <- sum(original)
    }
    else if (!is.numeric(n) || n < 1){
        stop('m has to be a positive number', call. = TRUE)
    }
    #=============================================================================
    
    nfeatures <- length(original)
    boot_replicates <- matrix(0, ncol = n, nrow = nfeatures)
    original <- original/m
    
    for(i in seq_len(n)){
        # partly from SignatureEstimation
        mutations_sampled <- sample(seq(nfeatures), m, replace = TRUE,
                                    prob = original)
        rep <- as.numeric(table(factor(mutations_sampled,
                                       levels = seq(nfeatures))))
        boot_replicates[,i] <- rep
    }
    
    rep_names <- paste0('replicate_', seq_len(n))
    colnames(boot_replicates) <- rep_names
    rownames(boot_replicates) <- rownames(original)
    return(boot_replicates)
}

## ----setup, include = FALSE---------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

## ----Load, message=FALSE------------------------------------------------------
library(SigsPack)

## -----------------------------------------------------------------------------
if (require(BSgenome.Hsapiens.UCSC.hg19)) {
  sample <- vcf2mut_cat(
    system.file("extdata", "example.vcf.gz", package="SigsPack"),
    BSgenome.Hsapiens.UCSC.hg19
  )
}

## -----------------------------------------------------------------------------
data("cosmicSigs")

cats <- create_mut_catalogues(10, 500, P=cosmicSigs, sig_set = c(2,6,15,27))
knitr::kable(head(cats[['catalogues']]))


## -----------------------------------------------------------------------------

reps <- bootstrap_mut_catalogues(n = 1000, original = cats[["catalogues"]][,1])

# using only signatures 4, 17, 23 and 30 for signature estimation
sigs <- signature_exposure(reps, sig_set = c(4,17,23,30))

print(sigs$exposures[,1])

## ----fig.show='hold', fig.height=7, fig.width=7-------------------------------

report <- summarize_exposures(reps[,1])

knitr::kable(
  head(report)
  )


## -----------------------------------------------------------------------------
if (require(BSgenome.Hsapiens.UCSC.hg19)){
  genome_contexts <- get_context_freq(BSgenome.Hsapiens.UCSC.hg19)
  exome_contexts <- get_context_freq(
    BSgenome.Hsapiens.UCSC.hg19,
    system.file("extdata", "example.bed.gz", package="SigsPack")
  )
  normalized_mut_cat <- SigsPack::normalize(sample, exome_contexts, hg19context_freq)
}

## ----fig.show='hold', fig.height=7, fig.width=7-------------------------------
if (require(BSgenome.Hsapiens.UCSC.hg19)) {
  sigs_norm <- signature_exposure(sum(sample) * normalized_mut_cat)
  report_norm <- summarize_exposures(normalized_mut_cat, m=sum(sample))
  reps_norm <- bootstrap_mut_catalogues(
      n=1000,
      original=normalized_mut_cat, 
      m=sum(sample)
  )
}

## -----------------------------------------------------------------------------
sessionInfo()

#' COSMIC v3 exome SBS Signature Profiles
#'
#' @format A matrix with 96 rows and 67 columns containing the signature 
#' profiles of the 67 consensus signatures as reported on COSMIC version 3.
#' 
#'\describe{
#'\item{SBS<N>}{The profile of signature SBS<N> representing the relative
#'proportions of mutations generated by each signature based on the 
#'trinucleotide frequencies of the reference human genome version GRCh37.
#'The signature profiles have been normalised for mutational catalogues
#'collected on exome datasets.}
#'}
#'
#' @source \url{https://cancer.sanger.ac.uk/cosmic/signatures/SBS/}
"sigProfilerExome"

#' Trinuecleotide frequencies of the human reference genome hg19
#'
#' @format A numeric vector with 32 elements
#' 
#'\describe{
#'\item{Trinucleotide}{The frequency of a certain trinucleotide context in the 
#'genome.}}
#'
#' @source BSgenome.Hsapiens.UCSC.hg19
#'
"hg19context_freq"

#' Extract occurence of tri-nucleotide contexts 
#' 
#' Extracts the frequencies of the tri-nucleotide contexts in a given region 
#' of the genome. These frequencies are needed to normalize a mutational 
#' catalogue. The output can be input to normalize().
#'
#' @param genome a BSgenome object
#' @param region a GRanges object, path, URL, connection or BEDFile object. 
#'
#' @return matrix containing the frequencies of the trinucleotide contexts
#' @examples 
#' gr<-GenomicRanges::GRanges(seqnames=c("chr1"),
#'           ranges=IRanges::IRanges(start=c(100000),end=c(1000000)),
#'           strand=c("+"))
#' get_context_freq(BSgenome.Hsapiens.UCSC.hg19::BSgenome.Hsapiens.UCSC.hg19, gr)
#' get_context_freq(BSgenome.Hsapiens.UCSC.hg19::BSgenome.Hsapiens.UCSC.hg19)
#' 
#' \dontrun{
#' get_context_freq(BSgenome.Hsapiens.UCSC.hg19::BSgenome.Hsapiens.UCSC.hg19, 'example.bed')
#' }
#' 
#' @export
get_context_freq <- function(genome, region=NULL){
    check <- lapply(c('BSgenome'), function(pack){
        if(!requireNamespace(pack, quietly = TRUE)){
            stop(paste0('Please install the library ', pack, 
                        ' to use this function.'),
                 call. = TRUE)
        }
    })
    
    if(!is(genome, 'BSgenome')){
        stop('Genome has to be a BSgenome object.',
             call. = TRUE)
    }
    #=============================================================================
    wanted <- c("ACA", "ACC", "ACG", "ACT", "ATA", "ATC", "ATG", "ATT", "CCA", 
                "CCC", "CCG", "CCT", "CTA", "CTC", "CTG", "CTT", "GCA", "GCC",
                "GCG", "GCT", "GTA", "GTC", "GTG", "GTT", "TCA", "TCC", "TCG",
                "TCT", "TTA", "TTC", "TTG", "TTT")
    #=============================================================================
    
    if (is.null(region)){
        tri_context <- matrix(ncol = 64, nrow = length(BSgenome::seqnames(genome)))
        
        # rewrite this somehow with apply?
        i <- 1
        for(chr in BSgenome::seqnames(genome)){
            tri_context[i,] <- Biostrings::trinucleotideFrequency(genome[[chr]])
            i <- i+1
        }
    }
    else{
        
        if(!is(region, 'GRanges')){
            region <- rtracklayer::import(con = region)
        }
        seq <- BSgenome::getSeq(genome, region)
        tri_context <- Biostrings::trinucleotideFrequency(seq)
    }
    
    tri_context_all <- as.data.frame(colSums(tri_context))
    rownames(tri_context_all) <- rownames(as.data.frame(
        Biostrings::trinucleotideFrequency(genome[[as.character(BSgenome::seqnames(genome)[1])]])))
    context_freq <- matrix(ncol = 1, nrow = 32)
    rownames(context_freq) <- wanted
    
    for (s in wanted){
        # get the reverse complement
        sr <- Biostrings::reverseComplement(Biostrings::DNAString(s))
        sr <- as.character(sr)
        context_freq[s,] <- tri_context_all[s,] + tri_context_all[sr,]
    }
    
    return(context_freq)
}

#' Normalize mutational catalogues 
#' 
#' Normalizes the catalogues to a target distribution (e.g. to match the 
#' distribution of the reference signatures).
#'
#' @param mut_cat mutational catalogues (96 by n, n being the amounts of 
#' catalogues) that will be normalized. The tri-nucleotide contexts are expected 
#' to be in the default lexicographical order (see simulated data or cosmicSigs)
#' @param source_context Distribution of tri-nucleotides in the source region.
#' @param target_context Distribution of tri-nucleotides in the target region.
#' Defaults to the context frequencies of BSgenome.Hsapiens.UCSC.hg19 since that
#' corresponds to the COSMIC signatures
#'
#' @return mutational catalogues (96 by n, n being the amounts of catalogues) 
#' normalized to match the target distribution (context)
#' 
#' @examples
#' # this is a toy example:
#' #create mutational catalogue:
#' sim_data <- create_mut_catalogues(1, 500)[['catalogues']]
#' # get trinucleotide frequencies for the genome:
#' genome_context <- get_context_freq(BSgenome.Hsapiens.UCSC.hg19::BSgenome.Hsapiens.UCSC.hg19)
#' #get trinucleotide frequencies for a specific region:
#' gr<-GenomicRanges::GRanges(seqnames=c("chr1"),
#'           ranges=IRanges::IRanges(start=c(100000),end=c(1000000)),
#'           strand=c("+"))
#' region_context<-get_context_freq(BSgenome.Hsapiens.UCSC.hg19::BSgenome.Hsapiens.UCSC.hg19, gr)
#' #normalize data:
#' normalized_mut_cat <- normalize(sim_data, region_context, genome_context)
#' 
#' \dontrun{
#' # get the tri-nucleotide distribution of an exome region
#' exome_contexts <- get_context_freq(BSgenome.Hsapiens.UCSC.hg19::BSgenome.Hsapiens.UCSC.hg19,
#'                                    'example_exome.bed')
#' 
#' # normalize the mutational catalogue to match the COSMIC signatures
#' normalized_mut_cat <- normalize(mut_cat, exome_contexts, hg19context_freq)
#' }
#' 
#' @note The output from get_context_freq() can be used as input to this 
#' function
#'
#' @export
normalize <- function(mut_cat, source_context,
                      target_context=get(utils::data("hg19context_freq", package="SigsPack"))){
    # TODO not usable for other contexts then the default 96 for now...
    
    if (! is.numeric(mut_cat)){
        stop('The mutational catalogues areexpected to contain only numbers.',
             call. = TRUE)
    }
    m <- as.matrix(mut_cat)
    if (nrow(m) != 96){
        stop('The mutational catalogues are expected to have 96 rows.',
             call. = TRUE)
    }    
    if (! is.numeric(source_context)){
        stop('The source context is expected to contain only numbers.',
             call. = TRUE)
    }
    if (! is.numeric(target_context)){
        stop('The target_context is expected to contain only numbers.',
             call. = TRUE)
    }
    if (length(source_context) != length(target_context)){
        stop('The source and target contexts have to have the same dimensions',
             call. = TRUE)
    }
    # more checks probably needed
    
    P <- get(utils::data("cosmicSigs", package="SigsPack"))
    rownames(m) <- rownames(P)
    
    # add a triplet column to the catalogue to compare to the contexts
    for(i in seq_len(96)){
        rownames(m)[i] <- paste0(substring(rownames(P)[i],1,1),
                                 substring(rownames(P)[i],3,3),
                                 substring(rownames(P)[i],7,7))
    }
    
    #normalize
    for(triplet in rownames(as.data.frame(target_context))){
        m[which(rownames(m) == triplet),] <- m[which(rownames(m) == triplet),]/
            (source_context[triplet,])*(target_context[triplet,])
    }
    
    rownames(m) <- rownames(P)
    m <- apply(m, 2, function(x) {
        x/sum(x)
    })
    
    return(m)
}

#' Plot signature exposure estimation for several samples
#'
#' Creates a boxplot illustrating the results of the signature estimation for 
#' several mutational catalogues (e.g. bootstrapped re-samples or a cohort). 
#' The plot shows the distribution of estimated signature exposure for all the 
#' catalogues, highlighting the one of the original mutational catalogue if one
#' is provided.
#'
#' @param bootstrapped_exposure matrix (n by k) containing the signature 
#' exposure of several mutational catalogues (bootstrapped re-samples)
#' n is the amount of re-samples
#' k is the amount of signature profiles that P contains
#' @param original_estimation matrix (n by k) containing the signature exposure
#' of one or several mutational catalogues (typically, the original sample) that
#' will be diplayed on top of the boxplots
#' @param title character, title of the plot
#' @param box_col color option of the boxplot
#' @param point_col color option of the points that indicate the exposure of the 
#' original profile(s). Should be a vector, if several original profiles are 
#' plotted
#' @param sig_names character vector, names of the signatures to be displayed as
#' x-axis labels
#' @param sample_names character vector, names of the original profile(s)
#'
#' @return
#' Diplays a boxplot
#' 
#' @note The function can of course also be used to plot the distribution 
#' of estimated signature exposures in a cohort instead of one bootstrapped 
#' sample.
#' 
#' @examples
#' # prepare input
#' data(cosmicSigs)
#' mut_cat <- create_mut_catalogues(4,400)
#' exposures <- signature_exposure(bootstrap_mut_catalogues(
#' 1000, mut_cat[['catalogues']][,1]))[['exposures']]
#' original_exposure <- signature_exposure(mut_cat[['catalogues']])[['exposures']]
#' 
#' plot_bootstrapped_exposure(exposures, as.matrix(original_exposure[,1]))
#' 
#' plot_bootstrapped_exposure(exposures, as.matrix(original_exposure), 
#' title='Example', box_col='grey')
#' 
#' @importFrom graphics boxplot axis points legend
#'
#' @export
plot_bootstrapped_exposure <- function(bootstrapped_exposure,
                                       original_estimation=NULL, 
                                       title=NULL, 
                                       box_col=NULL, 
                                       point_col=NULL, 
                                       sig_names=NULL,
                                       sample_names=NULL){
    
    if(!is.numeric(bootstrapped_exposure)){
        stop('The mutational catalogues should contain only numbers', call. = TRUE)
    }
    if(!is.null(original_estimation)){
        if(nrow(bootstrapped_exposure) != nrow(original_estimation)){
            stop('The bootstrapped exposures and the original estimation have to have the same amount of rows (signatures)', call. = TRUE)
        }
        else if(!is.numeric(original_estimation)){
            stop('The mutational catalogues should contain only numbers', call. = TRUE)
        }
        
        if(is.null(sample_names)){
            if (ncol(original_estimation) == 1){
                sample_names = 'original profile'
            }
            else{
                sample_names = as.character(seq_len(ncol(original_estimation)))
            }
        }
    }
    else{
        original_estimation <- c()
    }
    if(is.null(title)){
        title <- paste0('Bootstrap distribution ', sample_names[1])
    }
    else{
        if(!is.character(title)){
            stop('Title has to be a character vector', call. = TRUE)
        }
    }
    if(is.null(box_col)){
        box_col <- "aquamarine3"
    }
    if(is.null(point_col)){
        point_col <- c("darkorange3", "darkmagenta", "red", "blue", "black")
        
    }
    if(is.null(sig_names)){
        sig_names <- seq_len(nrow(bootstrapped_exposure))
    }
    else{
        if(length(sig_names)!=nrow(bootstrapped_exposure)){
            stop('Amount of sig_names has to match the amount of signatures', call.=TRUE)
        }
    }
    
    #============================================================================
    # Plot
    
    boxplot(t(bootstrapped_exposure), range = 0,
            ylim = c(0, (max(bootstrapped_exposure)+0.10)), frame=FALSE, 
            ylab = "Exposure", main = title, cex.axis = 1, xaxt = "n", 
            xlab = "Signatures", col = box_col)
    axis(1, seq_len(nrow(bootstrapped_exposure)), 
         labels = as.character(sig_names), las = 1, tick=FALSE, cex.axis = 0.7, 
         mgp = c(2,0.01,0))
    if(!is.null(original_estimation)){
        for(i in seq_len(ncol(original_estimation))){
            points(original_estimation[,i], pch = '*', col = point_col[i], 
                   cex = 2, lwd = 2)
        }
        legend('topleft', legend=sample_names,
               col=point_col, pch = '*', cex=1.2, box.lty=0)
    }
}

# get supp tables

#no Norm
vcf <- VariantAnnotation::readVcf(vcfPath)
seqs = as.character(seqnames(vcf)@values)[-length(as.character(seqnames(vcf)@values))]
profileX <- vcf2mut_cat(vcf, BSgenome.Hsapiens.1000genomes.hs37d5, seqs)
statsX <- statistics(profileX)

genomeCounts <- get_context_freq(BSgenome.Hsapiens.UCSC.hg19)
exomeCounts <- get_context_freq(BSgenome.Hsapiens.UCSC.hg19, exomePath)

# genome Norm
profileXgN <- normalize(profileX, exomeCounts, genomeCounts)
statsXgN <- statistics(profileXgN, m = colSums(profileX))

# exome Norm
exSigs <- normalize(cosmicSigs, genomeCounts, exomeCounts)
statsXeN = statistics(profileX, exSigs)

# uniNorm
uni <- rep(1,32)
uniSigs <- normalize(cosmicSigs, genomeCounts, uni)
profileXuN <- normalize(profileX[-length(profileX)], v4contexts, uni)
statsXuN <- statistics(profileXuN, P=uniSigs, m = colSums(profileX))


write.table(profile99_4uN, 
            file='~/Documents/sigPaper/signaturepackage/Paper/supp_tables/99/99_4profile_uniNorm.tsv', 
            quote=FALSE, 
            sep='\t', 
            col.names = NA)

stats99_4uN <- statistics(profile99_4uN, P=uniSigs , m=colSums(as.matrix(profile99_4[-length(profile99_4)])))
write.table(stats99_4uN, 
            file='~/Documents/sigPaper/signaturepackage/Paper/supp_tables/99/99_4stats_uniNorm.tsv', 
            quote=FALSE, 
            sep='\t', 
            col.names = NA)

write.table(uniSigs, 
            file='~/Documents/sigPaper/signaturepackage/Paper/supp_tables/cosmicSigs_uniNorm.tsv', 
            quote=FALSE, 
            sep='\t', 
            col.names = NA)


# comparing figures were done with genome norm profiles
all69 = cbind(profile69_1gN, profile69_2gN, profile69_4gN, profile69_5gN)
set.seed(123)
statistics(all69, m=colSums(as.matrix(profile99_4[-length(profile99_4)])))

set.seed(123)
ortho = summarize_exposures(create_mut_catalogues(1,1000, sig_set=c(7,13,21,24,28), c_exposure = c(0.2,0.2,0.2,0.2,0.2))[['catalogues']][,1])
write.table(ortho, 
            file='~/Documents/sigPaper/signaturepackage/Paper/supp_tables/set1.tsv', 
            quote=FALSE, 
            sep='\t', 
            col.names = NA)

set.seed(123)
set2 = summarize_exposures(create_mut_catalogues(1,1000, sig_set=c(3,5,8,16,25), c_exposure = c(0.2,0.2,0.2,0.2,0.2))[['catalogues']][,1])
write.table(set2, 
            file='~/Documents/sigPaper/signaturepackage/Paper/supp_tables/set2.tsv', 
            quote=FALSE, 
            sep='\t', 
            col.names = NA)

#' decomposeQP function
#'
#' This function is taken from the package 'SignatureEstimation' by Xiaoqing 
#' Huang and Damian Wojtowicz 
#' (source: https://www.ncbi.nlm.nih.gov/CBBresearch/Przytycka/index.cgi#signatureestimation)
#' The function allows to get the optimal solution by using dual method to solve
#' the quadratic programming problem.
#'
#'
#' @param m observed tumor profile vector for a single patient/sample, 96 by 1. 
#' m is normalized.
#' @param P signature profile matrix, 96 by N (N = # signatures, COSMIC: N=30)
#' @param ... control parameter that can be passed into the solve.QP 
#' function
#'
#' @return matrix containing estimated signature exposures
#'
#' @examples
#' data(cosmicSigs)
#' mut_cat<- (create_mut_catalogues(1,500)[['catalogues']])/500
#' decomposeQP(mut_cat, cosmicSigs)
#' @export
decomposeQP <- function (m, P, ...)
{
    N = ncol(P)
    G = t(P) %*% P
    C <- cbind(rep(1, N), diag(N))
    b <- c(1, rep(0, N))
    d <- t(m) %*% P
    out = quadprog::solve.QP(Dmat = G, dvec = d, Amat = C, bvec = b,
                             meq = 1)
    exposures = out$solution
    exposures[exposures < 0] = 0
    exposures = exposures/sum(exposures)
    return(exposures)
}

#' Derive the mutational catalogue from a vcf
#'
#' Creates a matrix containing the mutational catalogue from a vcf file or 
#' object. The result can be input to the analysis functions of this package.
#'
#' @param vcf *.vcf file or a vcf object containing variant calling data for one
#'  patient
#' @param genome a BSgenome object corresponding to the genome the variants were
#' called on
#' @param name optional, a sample name 
#' @param seqs optional, a character vector containing the names of the 
#' sequences that are to be included in the mutational profile. If none is given
#' everything will we included
#'
#' @return mutational catalogue (matrix) of a patient containing SNV absolute 
#' counts (in the 96 trinucleotide context)
#' format: 1 by 96
#'
#' @note The execution can take some time, depending on the size of the vcf 
#'
#' @importFrom stats na.omit
#' @importFrom methods is
#'
#' @examples
#' \dontrun{
#' vcf2mut_cat('test.vcf', BSgenome.Hsapiens.UCSC.hg19::BSgenome.Hsapiens.UCSC.hg19)
#' }
#' @export
vcf2mut_cat <- function(vcf, genome, name=NULL, seqs=NULL){
    
    if(!requireNamespace('VariantAnnotation', quietly = TRUE)){
        stop(paste0('Please install the library 
                VariantAnnotation to use this function.'),
              call. = TRUE)
    }
    
    # if vcf is a file path, first import
    if(is.character(vcf)){
        vcf <- VariantAnnotation::readVcf(vcf)
    }
    
    check <- lapply(c('BSgenome', 'SummarizedExperiment'), function(pack){
        if(!requireNamespace(pack, quietly = TRUE)){
            stop(paste0('Please install the library ', pack, 
                        ' to use this function.'),
                 call. = TRUE)
        }
    })
    
    if (missing(vcf) || is.null(vcf) || !is(vcf, "VCF"))
        stop("Missing or illegal vcf", call. = TRUE)
    if (is.null(genome) || !is(genome, "BSgenome"))
        stop("The genome has to be a BSgenome object", call. = TRUE)
    
    # Test if genome names match
    genome_names <- sort(unique(stats::na.omit(GenomeInfoDb::genome(vcf))))
    if (length(genome_names) == 0) {
        warning("vcf has no genome name")
    } else {
        if (!all(genome_names %in% GenomeInfoDb::genome(genome)))
            warning("vcf genome \"",
                    paste(genome_names, collapse=", "),
                    "\" not in genome \"",
                    paste(sort(unique(na.omit(GenomeInfoDb::genome(genome)))), collapse=", "),
                    "\"")
    }
    
    # Remove all variants not in the genome
    vcf <- vcf[as.character(
        GenomicRanges::seqnames(vcf)) %in% BSgenome::seqnames(genome),]
    
    # Only keep variants of specified areas
    if (!is.null(seqs)){
        if(!is.character(seqs)){
            stop("seqs has to be a character vector or NULL", call. = TRUE)
        }
        vcf <- vcf[as.character(
            GenomicRanges::seqnames(vcf)) %in% seqs,]
    }
    
    if (nrow(vcf) == 0) {
        warning("no mutation overlap between vcf & genome", call. = TRUE)
        return(NULL)
    }
    
    # Remove all non-SNV variants
    vcf <- vcf[GenomicRanges::width(vcf)==1,]
    if (nrow(vcf) == 0) {
        warning("no SNV mutation", call. = TRUE)
        return(NULL)
    }
    # Set the strand to "unknown", required for promoter
    locii <- SummarizedExperiment::rowRanges(vcf)
    GenomicRanges::strand(locii) <- "*"
    
    # Extract mutation contexts
    mutation_contexts <- GenomicRanges::promoters(
        x=locii,
        upstream=1, downstream=2
    )
    
    # Remove illegal contexts (outside sequence boundaries)
    lens <- GenomeInfoDb::seqlengths(BSgenome::seqinfo(genome))
    i <- which(
        GenomicRanges::start(mutation_contexts)<1 |
            GenomicRanges::end(mutation_contexts)>lens[as.character(
                GenomicRanges::seqnames(mutation_contexts))]
    )
    if (length(i)>0) {
        warning(length(i), " mutations at sequences boundaries, ignored", 
                call. = TRUE)
        mutation_contexts <- mutation_contexts[-i,]
        if (length(i) == 0) return(NULL)
    }
    
    # Extract sequences
    seqs <- Biostrings::DNAStringSet(BSgenome::Views(genome, mutation_contexts))
    ref <- SummarizedExperiment::rowRanges(vcf)$REF
    alt <- unlist(SummarizedExperiment::rowRanges(vcf)$ALT)
    
    #format to match consensus
    mut_cat <- matrix(0L,ncol = 1, nrow = 96)
    rownames(mut_cat) <- rownames(get(utils::data("cosmicSigs", package="SigsPack")))
    for(i in seq_len(length(seqs))){
        if(as.character(ref[i]) %in% c('A', 'G')){
            seqsI <- as.character(Biostrings::reverseComplement(seqs[i]))
            altI <- Biostrings::reverseComplement(alt[i])
        }
        else{
            altI <- alt[i]
            seqsI <- as.character(seqs[i])
        }
        context <- paste0(substring(seqsI,1,1), '[',
                          substring(seqsI,2,2), '>',
                          altI, ']',
                          substring(seqsI,3,3))
        mut_cat[which(context == rownames(mut_cat))] <- mut_cat[which(context == rownames(mut_cat))] + 1
    }
    
    if (!is.null(name) && is.character(name)){
        colnames(mut_cat) <- name 
    }
    
    return(mut_cat)
}

---
title: "Introduction to SigsPack"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Introduction to SigsPack}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r setup, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

Sigspack provides tools for easy computation of signature exposures from 
mutational catalogues. 

The package provides several features, allowing to read 
the primary mutation data, normalise the mutational catalogues if necessary and
compute signature exposures with their bootstrapped variation estimates.


## Loading the package

```{r Load, message=FALSE}
library(SigsPack)
```

## Loading a VCF

In most cases you will want to analyse real data, e.g. fit a sample's mutational
profile to known mutational signatures. You can easily load your data and use it
with the package.

```{r}
if (require(BSgenome.Hsapiens.UCSC.hg19)) {
  sample <- vcf2mut_cat(
    system.file("extdata", "example.vcf.gz", package="SigsPack"),
    BSgenome.Hsapiens.UCSC.hg19
  )
}
```

It will be transformed into a 'mutational profile' sorting all single nucleotide
variants according to their trinucleotide context and mutation. The result is a 
96 by 1 matrix that can be used as input to the analysis functions of the
package as well as in most other packages of this field.

## Simulating data

Instead of using real-life data it is also possible to generate 
synthetic data that can be used to analyse signatures stability. 
The following code generates 10 mutational catalogues  with exposure to the 
COSMIC signatures 2, 6, 15 and 27. The catalogues consist of mutation counts 
sampled from a distribution that is a linear combination of the aforementioned 
signatures. The weight of each of these signatures can optionally be specified, 
too. For convenience, the COSMIC reference signature matrix is included in the
package and used as default in the functions. However, it is also possible to 
use all functions with a custom signature matrix.
```{r}
data("cosmicSigs")

cats <- create_mut_catalogues(10, 500, P=cosmicSigs, sig_set = c(2,6,15,27))
knitr::kable(head(cats[['catalogues']]))

```


## Estimating signature exposures and bootstrapping samples

The function bootstrap_mut_catalogues bootstraps a sample returning a specified
amount of re-samples which can be used to gain a better variability estimation 
of the sample’s signature exposure.

The signature exposure is calculated using quadratic programming. This can be 
done on one or several samples at once. The COSMIC signatures have been included
in the package, and are used by default. However, it is possible to use your own
signature matrix, or use a sub-set of COSMIC signatures, instead of the whole 
matrix.
```{r}

reps <- bootstrap_mut_catalogues(n = 1000, original = cats[["catalogues"]][,1])

# using only signatures 4, 17, 23 and 30 for signature estimation
sigs <- signature_exposure(reps, sig_set = c(4,17,23,30))

print(sigs$exposures[,1])
```

With one command you can bootstrap a mutational catalogue and obtain a table and
a plot illustrating the results of the signature estimation for this sample and 
the bootstrapped re-samples. The plot shows the distribution of estimated 
signature exposure for all the re-samples, highlighting the one of the original 
mutational catalogue, thus providing insights on the reliability of the 
estimates.
```{r, fig.show='hold', fig.height=7, fig.width=7}

report <- summarize_exposures(reps[,1])

knitr::kable(
  head(report)
  )

```

## Tri-nucleotide contexts and normalization
Accurate exposures estimation requires matching tri-nucleotide frequencies 
between observations and the signature matrix. The COSMIC signature matrix 
provided in the package is relative to the whole genome (GRCh37) tri-nucleotide 
frequencies. So if you want to fit those signatures to exome data, the data need
to be normalized to match the signatures prior to exposures estimation. 

Let's say, that the vcf we derived the mutational catalogue from contained exome
data. In the case of this example, we want to scale our exome data to the
genome 'space' to match the COSMIC reference signatures. Hence, we need both the 
tri-nucleotide distribution of the human genome (GRCh37) and the exome that our 
data were collected on.

Extract the tri-nucleotide context frequencies from a genome (BSgenome 
object) or exome and use them to normalize the data.
```{r}
if (require(BSgenome.Hsapiens.UCSC.hg19)){
  genome_contexts <- get_context_freq(BSgenome.Hsapiens.UCSC.hg19)
  exome_contexts <- get_context_freq(
    BSgenome.Hsapiens.UCSC.hg19,
    system.file("extdata", "example.bed.gz", package="SigsPack")
  )
  normalized_mut_cat <- SigsPack::normalize(sample, exome_contexts, hg19context_freq)
}
```

The normalization returns frequencies, not count numbers. If you want to use them
for exposure estimation or for bootstrapping, the catalogue size must be scaled,
or input together with the normalized catalogue.
```{r, fig.show='hold', fig.height=7, fig.width=7}
if (require(BSgenome.Hsapiens.UCSC.hg19)) {
  sigs_norm <- signature_exposure(sum(sample) * normalized_mut_cat)
  report_norm <- summarize_exposures(normalized_mut_cat, m=sum(sample))
  reps_norm <- bootstrap_mut_catalogues(
      n=1000,
      original=normalized_mut_cat, 
      m=sum(sample)
  )
}
```

## sessionInfo
```{r}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/get_context_freq.R
\name{get_context_freq}
\alias{get_context_freq}
\title{Extract occurence of tri-nucleotide contexts}
\usage{
get_context_freq(genome, region = NULL)
}
\arguments{
\item{genome}{a BSgenome object}

\item{region}{a GRanges object, path, URL, connection or BEDFile object.}
}
\value{
matrix containing the frequencies of the trinucleotide contexts
}
\description{
Extracts the frequencies of the tri-nucleotide contexts in a given region 
of the genome. These frequencies are needed to normalize a mutational 
catalogue. The output can be input to normalize().
}
\examples{
gr<-GenomicRanges::GRanges(seqnames=c("chr1"),
          ranges=IRanges::IRanges(start=c(100000),end=c(1000000)),
          strand=c("+"))
get_context_freq(BSgenome.Hsapiens.UCSC.hg19::BSgenome.Hsapiens.UCSC.hg19, gr)
get_context_freq(BSgenome.Hsapiens.UCSC.hg19::BSgenome.Hsapiens.UCSC.hg19)

\dontrun{
get_context_freq(BSgenome.Hsapiens.UCSC.hg19::BSgenome.Hsapiens.UCSC.hg19, 'example.bed')
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/create_mut_catalogues.R
\name{create_mut_catalogues}
\alias{create_mut_catalogues}
\title{Creates simulated mutational catalogues}
\usage{
create_mut_catalogues(n, m, P = get(utils::data("cosmicSigs", package =
  "SigsPack")), sig_set = NULL, c_exposure = NULL)
}
\arguments{
\item{n}{Amount of mutational catalogues that will be created}

\item{m}{Amount of mutations that each catalogues will have}

\item{P}{Matrix (f x k) containing the signature profiles of k signatures
which will be used to create the catalogues
k is the amount of signature profiles that P contains
f is the amount of features that the profiles are defined on
(default: COSMIC signature matrix 96 x 30) (optional)}

\item{sig_set}{Numeric vector containing the index of the columns from P
(which are the signature profiles) that will be used to create the catalogues
(optional). Defaults to all columns of P.}

\item{c_exposure}{Numeric vector specifying the contribution of each 
signature to the distribution each sample is drawn from. Samples will have an
appr. exposure of c_exposure[idx] to signature sig_set[idx] 
(if sum(c_exposure)==1). (optional)
Default: random exposure.}
}
\value{
List containing a matrix (f x n) with the simulated catalogues and a
matrix (k x n) detailing the signature exposure of each catalogue
}
\description{
Creates mutational catalogues from chosen mutational signature profiles to
gain simualted data sampled from a distirbution with with known signature
contribution
}
\examples{
data(cosmicSigs)
sim_data <- create_mut_catalogues(10, 300, cosmicSigs, c(2,6,15,27))
sim_data <- create_mut_catalogues(1000, 500)
sim_data <- create_mut_catalogues(1, 500, sig_set = c(1,4,29), c_exposure = c(0.25, 0.65, 0.1))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/summarize_exposures.R
\name{summarize_exposures}
\alias{summarize_exposures}
\title{Signature exposure analysis of a mutational catalogue}
\usage{
summarize_exposures(mut_cat, P = get(utils::data("cosmicSigs", package =
  "SigsPack")), plotting = TRUE, m = NULL)
}
\arguments{
\item{mut_cat}{mutational catalogue (96 by 1)}

\item{P}{Matrix (f x k) containing the signature profiles of k
signatures whose exposure is to be found
k is the amount of signature profiles that P contains
f is the amount of features that the profiles are defined on
(default: COSMIC signature matrix 96 by 30)}

\item{plotting}{boolean, TRUE by default, if True,  a boxplot showing the 
distribution of estimated signature exposure for all the re-samples, 
highlighting the one of the original mutational catalogue, thus providing 
insights on the reliability of the estimates}

\item{m}{numeric, amount of mutations in the profile (needed for 
bootstrapping in case mut_cat doesn't contain absolute counts.)}
}
\value{
table (k by 6) containing statistics for each signature about the 
estimated exposure over 1000 bootstrapped resamples
- original exposure estimated exposure of the original mutational profile
- min minimum estimated exposure to this signature
- 1. quartile
- median 
- 3. quartile
- max maximum estimated exposure to this signature

if the plotting option is chosen, a boxplot will also be displayed
}
\description{
Bootstrapps a mutational catalogue and details the results about the 
signature estimation in a table and a boxplot
}
\examples{
summarize_exposures(create_mut_catalogues(10,500)[['catalogues']][,1], plotting=FALSE)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sigProfilerExome.R
\docType{data}
\name{sigProfilerExome}
\alias{sigProfilerExome}
\title{COSMIC v3 exome SBS Signature Profiles}
\format{A matrix with 96 rows and 67 columns containing the signature 
profiles of the 67 consensus signatures as reported on COSMIC version 3.

\describe{
\item{SBS<N>}{The profile of signature SBS<N> representing the relative
proportions of mutations generated by each signature based on the 
trinucleotide frequencies of the reference human genome version GRCh37.
The signature profiles have been normalised for mutational catalogues
collected on exome datasets.}
}}
\source{
\url{https://cancer.sanger.ac.uk/cosmic/signatures/SBS/}
}
\usage{
sigProfilerExome
}
\description{
COSMIC v3 exome SBS Signature Profiles
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/normalize.R
\name{normalize}
\alias{normalize}
\title{Normalize mutational catalogues}
\usage{
normalize(mut_cat, source_context,
  target_context = get(utils::data("hg19context_freq", package =
  "SigsPack")))
}
\arguments{
\item{mut_cat}{mutational catalogues (96 by n, n being the amounts of 
catalogues) that will be normalized. The tri-nucleotide contexts are expected 
to be in the default lexicographical order (see simulated data or cosmicSigs)}

\item{source_context}{Distribution of tri-nucleotides in the source region.}

\item{target_context}{Distribution of tri-nucleotides in the target region.
Defaults to the context frequencies of BSgenome.Hsapiens.UCSC.hg19 since that
corresponds to the COSMIC signatures}
}
\value{
mutational catalogues (96 by n, n being the amounts of catalogues) 
normalized to match the target distribution (context)
}
\description{
Normalizes the catalogues to a target distribution (e.g. to match the 
distribution of the reference signatures).
}
\note{
The output from get_context_freq() can be used as input to this 
function
}
\examples{
# this is a toy example:
#create mutational catalogue:
sim_data <- create_mut_catalogues(1, 500)[['catalogues']]
# get trinucleotide frequencies for the genome:
genome_context <- get_context_freq(BSgenome.Hsapiens.UCSC.hg19::BSgenome.Hsapiens.UCSC.hg19)
#get trinucleotide frequencies for a specific region:
gr<-GenomicRanges::GRanges(seqnames=c("chr1"),
          ranges=IRanges::IRanges(start=c(100000),end=c(1000000)),
          strand=c("+"))
region_context<-get_context_freq(BSgenome.Hsapiens.UCSC.hg19::BSgenome.Hsapiens.UCSC.hg19, gr)
#normalize data:
normalized_mut_cat <- normalize(sim_data, region_context, genome_context)

\dontrun{
# get the tri-nucleotide distribution of an exome region
exome_contexts <- get_context_freq(BSgenome.Hsapiens.UCSC.hg19::BSgenome.Hsapiens.UCSC.hg19,
                                   'example_exome.bed')

# normalize the mutational catalogue to match the COSMIC signatures
normalized_mut_cat <- normalize(mut_cat, exome_contexts, hg19context_freq)
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bootstrap_mut_catalogues.R
\name{bootstrap_mut_catalogues}
\alias{bootstrap_mut_catalogues}
\title{Bootstraps a given mutational catalogue}
\usage{
bootstrap_mut_catalogues(n, original, m = NULL)
}
\arguments{
\item{n}{Amount of bootstrapped replicates that are created (they will by
default have the same amount of mutations as the original catalogue)}

\item{original}{Mutational catalogue (matrix) of a sample that is taken as
the distribution from which the replicates are sampled}

\item{m}{Amount of mutations the replicates are supposed to have
(e.g. if this differs from the original or if the original is provided as
probabilities instead of total counts)}
}
\value{
matrix containing the mutational catalogues of the replicates
}
\description{
Bootstraps a given mutational catalogue  by replicating samples from the
original catalogue's distribution of mutational features. The output can be
input to signature_exposure.
}
\examples{
data(cosmicSigs)
reps <- bootstrap_mut_catalogues(n = 150, original = create_mut_catalogues(
                                  10, 500)[["catalogues"]][,1])

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cosmicSigs.R
\docType{data}
\name{cosmicSigs}
\alias{cosmicSigs}
\title{COSMIC Signature Profiles}
\format{A matrix with 30 rows and 96 columns containing the signature 
profiles of the 30 consensus signatures as reported on COSMIC.

\describe{
\item{Signature N}{The profile of signature N representing the relative
proportions of mutations generated by each signature based on the 
trinucleotide frequencies of hte reference human genome version GRCh37.}#'}}
\source{
\url{https://cancer.sanger.ac.uk/cancergenome/assets/signatures_probabilities.txt}
}
\usage{
cosmicSigs
}
\description{
COSMIC Signature Profiles
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot_bootstrapped_exposure.R
\name{plot_bootstrapped_exposure}
\alias{plot_bootstrapped_exposure}
\title{Plot signature exposure estimation for several samples}
\usage{
plot_bootstrapped_exposure(bootstrapped_exposure,
  original_estimation = NULL, title = NULL, box_col = NULL,
  point_col = NULL, sig_names = NULL, sample_names = NULL)
}
\arguments{
\item{bootstrapped_exposure}{matrix (n by k) containing the signature 
exposure of several mutational catalogues (bootstrapped re-samples)
n is the amount of re-samples
k is the amount of signature profiles that P contains}

\item{original_estimation}{matrix (n by k) containing the signature exposure
of one or several mutational catalogues (typically, the original sample) that
will be diplayed on top of the boxplots}

\item{title}{character, title of the plot}

\item{box_col}{color option of the boxplot}

\item{point_col}{color option of the points that indicate the exposure of the 
original profile(s). Should be a vector, if several original profiles are 
plotted}

\item{sig_names}{character vector, names of the signatures to be displayed as
x-axis labels}

\item{sample_names}{character vector, names of the original profile(s)}
}
\value{
Diplays a boxplot
}
\description{
Creates a boxplot illustrating the results of the signature estimation for 
several mutational catalogues (e.g. bootstrapped re-samples or a cohort). 
The plot shows the distribution of estimated signature exposure for all the 
catalogues, highlighting the one of the original mutational catalogue if one
is provided.
}
\note{
The function can of course also be used to plot the distribution 
of estimated signature exposures in a cohort instead of one bootstrapped 
sample.
}
\examples{
# prepare input
data(cosmicSigs)
mut_cat <- create_mut_catalogues(4,400)
exposures <- signature_exposure(bootstrap_mut_catalogues(
1000, mut_cat[['catalogues']][,1]))[['exposures']]
original_exposure <- signature_exposure(mut_cat[['catalogues']])[['exposures']]

plot_bootstrapped_exposure(exposures, as.matrix(original_exposure[,1]))

plot_bootstrapped_exposure(exposures, as.matrix(original_exposure), 
title='Example', box_col='grey')

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/signature_exposure.R
\name{signature_exposure}
\alias{signature_exposure}
\title{Estimates the signature exposure of a mutational catalogue}
\usage{
signature_exposure(mut_cat, P = get(utils::data("cosmicSigs", package =
  "SigsPack")), sig_set = NULL, FUN = decomposeQP, ...)
}
\arguments{
\item{mut_cat}{matrix (f by n) conatining one or several mutational 
catalogues of samples whose signature exposures are to be estimated
f is the amount of features that the profiles are defined on
n is the number of catalogues}

\item{P}{Matrix (f by k) containing the signature profiles of k
signatures whose exposure is to be found
k is the amount of signature profiles that P contains
f is the amount of features that the profiles are defined on
(default: COSMIC signature matrix 96 x 30)}

\item{sig_set}{Numeric vector containing the index of the columns from the
signature matrix (which are the signature profiles) that will be used
reconstruct the mutational catalogue.}

\item{FUN}{Function to estimate the signature exposure. Default: Quadratic 
programming (P has to be of full rank to use this method)}

\item{...}{control parameters that will be passed to FUN}
}
\value{
List of the estimated signature exposure, the reconstructed profile
of the sample, the cosine similarity between the two and the error
}
\description{
Estimates the signature exposure of a mutational catalogue by reconstructing
it from a chosen set of signatures, by default, the used method is quadratic
programming
}
\examples{
data(cosmicSigs)
signature_exposure(create_mut_catalogues(10,500)[['catalogues']])
signature_exposure(create_mut_catalogues(10,500)[['catalogues']], sig_set = c(2,7,16,28,30))
signature_exposure(as.matrix(create_mut_catalogues(10,500)[['catalogues']][,1]))



}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/decomposeQP.R
\name{decomposeQP}
\alias{decomposeQP}
\title{decomposeQP function}
\usage{
decomposeQP(m, P, ...)
}
\arguments{
\item{m}{observed tumor profile vector for a single patient/sample, 96 by 1. 
m is normalized.}

\item{P}{signature profile matrix, 96 by N (N = # signatures, COSMIC: N=30)}

\item{...}{control parameter that can be passed into the solve.QP 
function}
}
\value{
matrix containing estimated signature exposures
}
\description{
This function is taken from the package 'SignatureEstimation' by Xiaoqing 
Huang and Damian Wojtowicz 
(source: https://www.ncbi.nlm.nih.gov/CBBresearch/Przytycka/index.cgi#signatureestimation)
The function allows to get the optimal solution by using dual method to solve
the quadratic programming problem.
}
\examples{
data(cosmicSigs)
mut_cat<- (create_mut_catalogues(1,500)[['catalogues']])/500
decomposeQP(mut_cat, cosmicSigs)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/vcf2mut_cat.R
\name{vcf2mut_cat}
\alias{vcf2mut_cat}
\title{Derive the mutational catalogue from a vcf}
\usage{
vcf2mut_cat(vcf, genome, name = NULL, seqs = NULL)
}
\arguments{
\item{vcf}{*.vcf file or a vcf object containing variant calling data for one
patient}

\item{genome}{a BSgenome object corresponding to the genome the variants were
called on}

\item{name}{optional, a sample name}

\item{seqs}{optional, a character vector containing the names of the 
sequences that are to be included in the mutational profile. If none is given
everything will we included}
}
\value{
mutational catalogue (matrix) of a patient containing SNV absolute 
counts (in the 96 trinucleotide context)
format: 1 by 96
}
\description{
Creates a matrix containing the mutational catalogue from a vcf file or 
object. The result can be input to the analysis functions of this package.
}
\note{
The execution can take some time, depending on the size of the vcf
}
\examples{
\dontrun{
vcf2mut_cat('test.vcf', BSgenome.Hsapiens.UCSC.hg19::BSgenome.Hsapiens.UCSC.hg19)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hg19context_freq.R
\docType{data}
\name{hg19context_freq}
\alias{hg19context_freq}
\title{Trinuecleotide frequencies of the human reference genome hg19}
\format{A numeric vector with 32 elements

\describe{
\item{Trinucleotide}{The frequency of a certain trinucleotide context in the 
genome.}}}
\source{
BSgenome.Hsapiens.UCSC.hg19
}
\usage{
hg19context_freq
}
\description{
Trinuecleotide frequencies of the human reference genome hg19
}
\keyword{datasets}
